name: Build & Test - testing

on:
  push:
    branches:
     - '!release/**'
     - 'test'
  workflow_dispatch:   
env:
  REGISTRY_HOST: ${{ secrets.REGISTRY_HOST }}
  REGISTRY_USER: ${{ secrets.REGISTRY_USER }}
  REGISTRY_PASS: ${{ secrets.REGISTRY_PASS }}
  KUBE_CONFIG_DEV: ${{ secrets.KUBE_CONFIG_DEV }}
  SERVICE_NAME: sartorius-frontend

jobs:
  build:
    name: Build, Publish
    runs-on: dev
    steps:
    - name: Checkout
      uses: actions/checkout@master

    # Build the Docker image
    - name: Build frontend
      run: |
        sed -i 's/api-dev.sartorius.local/api-test.sartorius.devstack.fun/g' .env 
        docker build -t $REGISTRY_HOST/$SERVICE_NAME:${GITHUB_SHA::6} .
    
    - name: Configure AWS credentials
      uses: aws-actions/configure-aws-credentials@v1
      with:
        aws-access-key-id: ${{ secrets.AWS_ACCESS_KEY_ID }}
        aws-secret-access-key: ${{ secrets.AWS_SECRET_ACCESS_KEY }}
        aws-region: us-east-1
        
    # Push the Docker image to Registry
    - name: Publish image backend
      run: |
        aws ecr get-login-password --region us-east-1 | docker login --username AWS --password-stdin https://${REGISTRY_HOST}
        docker push $REGISTRY_HOST/$SERVICE_NAME:${GITHUB_SHA::6}
        docker rmi $(docker images --format '{{.Repository}}:{{.Tag}}' | grep ${REGISTRY}/${SERVICE_NAME})

    # Install helm
    - name: Install Helm
      run: |
        curl https://raw.githubusercontent.com/helm/helm/master/scripts/get-helm-3 > get_helm.sh
        chmod 700 get_helm.sh
        ./get_helm.sh

    # Deploy k8s
    - name: Deploy frontend
      run: |
        echo $KUBE_CONFIG_DEV | base64 -d > ~/.kube/config  
        helm upgrade --install -n test $SERVICE_NAME ./helm -f ./helm/values.yml \
          --set releaseOverride=$SERVICE_NAME \
          --set image.repository="$REGISTRY_HOST/$SERVICE_NAME" \
          --set image.tag=${GITHUB_SHA::6}
           
